#version 130
// Resolve gbuffer

#pragma fragment_shader

in vec2 coord;
out vec4 fragment;

uniform sampler2D bufferD;
uniform sampler2D mask;
uniform mat4 inverseView;
uniform mat4 proj;

vec3 constructViewPosition(vec3 coord, mat4 proj) {
	vec3 p = coord * 2.0 - 1.0;
	float A = proj[2].z;
	float B = proj[3].z;
	float z = -B / (A + p.z);
	vec2 div = vec2(proj[0].x, proj[1].y);
	vec2 skew = proj[2].xy;
	return vec3( (-z*p.xy + skew*z) / div, z);
}

void main() {
	float depth = texture2D(bufferD, coord.xy).x;
	vec3 position = constructViewPosition( vec3(coord, depth), proj);
	position = (inverseView * vec4(position,1)).xyz;

	ivec2 size = textureSize(mask, 0);
	float value = texture2D(mask, position.xy/vec2(size)).r;
	fragment = vec4(0, 0, 0, 1-value);
}


